/*
 *
 * Copyright (c) 2025. Jeffery Hsu - Achievement Report Generator
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <https://www.gnu.org/licenses/>.
 *
 */
export abstract class BaseFactoryClass {
  public static factory() {
    throw new Error('Method not implemented.')
  }

  public static factoryToImpl<T>(): T {
    throw new Error('Method not implemented.')
  }

  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  public static factoryFromImpl<T>(_impl: T): T {
    throw new Error('Method not implemented.')
  }
}

export abstract class ExposeImplGetter<T> {
  getCurrentImpl(): T {
    throw new Error('Method not implemented.')
  }
}

export abstract class ExposeImplSetter<T> {
  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  public setFromImpl(_impl: T): void {
    throw new Error('Method not implemented.')
  }
}
